\section{Background} %Related work}
\label{sec:background}

%\subsection{Runtime systems, sequential task flow and replicated data access}
%\label{sec:back.rt-stf}

Runtime systems have been studied extensively in the past decades to
overcome the lack of portability and flexibility of the MPI+X
approach.  Numerous runtime systems have been developed over the
years; an extensive review of runtime systems is given
by~\citeauthor{t:18}~\cite{t:18}.  Our interest is geared towards
runtime systems that rely on task-based parallelism, specifically
through the use of the STF programming model.  The STF programming
model is commonly appreciated because of its simplicity which allows,
in a relatively easy way, to transform a sequential code into a
parallel one while preserving its readability and
maintainability. Indeed the STF programming model key component is the
\texttt{insert\_task} routine which is used to delegate to the runtime
system the execution of elementary operations called
\textit{tasks}. These are arranged in a directed acyclic graph (DAG)
that expresses their mutual dependencies that have to be fulfilled to
achieve a correct result. These dependencies can be automatically
detected by the runtime thanks to access modes that decorate the data
manipulated by tasks. The runtime needs full control over the data to
move it wherever the execution of tasks is scheduled; therefore the
user has to register the data to the runtime and can only refer to it
through \textit{handles}.
\begin{ab}
  Je pense qu'il faudrait ajouter plus de details ici. Par exemple,
  dans la suite il y a des trucs qui ne sont pas proprement introduits
  comme la ownership des données, les rank, les handles (j'ai ajouté
  qqs details ci-dessus), les codelets, \texttt{ON\_RANK}... Par
  exemple, dans III.B on dit ``all the ranks have registered'' et
  c'est pas clair pourquoi ca doit etre le cas. Donc a mon avis on
  devrait avoir une bonne introduction du STF où on explique tous les
  details et comment les choses se passent dans un contexte memoire
  distribuée.
\end{ab}

A simple algorithm is described in Figure~\ref{fig:diamond_dag} that processes
two data $A_0$ and $A_1$ through 4 tasks. A pseudocode is given in
Figure~\ref{fig:diamond_dag.code} for which a DAG is depicted in
Figure~\ref{fig:diamond_dag.dag}. An STF implementation is proposed in
Figure~\ref{alg:diamond_stf}. The reader can appreciate how the
expression is very similar to the one of the sequential code: the role
of the programmer is simply to delegate function calls to the runtime system.
\begin{ab}
  j'ajouterais le register dans le code. Apres on dira que ``for the
  sake of brevity, we will omit the data registration in the rest of
  the document''.
\end{ab}

\begin{figure}
	\centering
	\begin{subfigure}{0.49\columnwidth}
		\centering
		\begin{tikzpicture}
		\node[draw,circle] (a) at (0,0) {$a$};
		\node[draw,circle] (b) at (-1,-1) {$b$};
		\node[draw,circle] (c) at (1,-1) {$b$};
		\node[draw,circle] (d) at (0,-2) {$c$};
		\path[draw,-latex] (a) -- (b);
		\path[draw,-latex] (a) -- (c);
		\path[draw,-latex] (b) -- (d);
		\path[draw,-latex] (c) -- (d);
		\end{tikzpicture}
		\caption{A diamond DAG.}
		\label{fig:diamond_dag.dag}
	\end{subfigure}
	\begin{subfigure}{0.49\columnwidth}
		\centering
		\begin{algorithmic}[H]
			\STATE $A_0$,$A_1$ = a()\;
			\STATE $A_0$       = b($A_0$)\;
			\STATE $A_1$       = b($A_1$)\;
			\STATE c($A_0$,$A_1$)\;
			\caption{Pseudo-code expression.}
			\label{fig:diamond_dag.code}
		\end{algorithmic}
	\end{subfigure}
	\begin{subfigure}{1.0\columnwidth}
		\centering
		\begin{algorithmic}[H]
			\STATE \textcolor{myred}{\stfinsert}(a, $A_0$:\textcolor{myred}{\stfW}, $A_1$:\textcolor{myred}{\stfW})\;
			\STATE \textcolor{myred}{\stfinsert}(b, $A_0$:\textcolor{myred}{\stfRW})\;
			\STATE \textcolor{myred}{\stfinsert}(b, $A_1$:\textcolor{myred}{\stfRW})\;
			\STATE \textcolor{myred}{\stfinsert}(c, $A_0$:\textcolor{myred}{\stfR}, $A_1$:\textcolor{myred}{\stfR})\;
			\caption{STF expression.}
			\label{alg:diamond_stf}
		\end{algorithmic}
	\end{subfigure}
	\caption
	{Diamond graph with 4 tasks. \textbf{Left:} the DAG that can be
scheduled with each task assigned a letter. \textbf{Right:} a pseudocode of
	a sequential execution. \textbf{Bottom:} an STF implementation.
	Note that tasks $b$ which are at the same depth in the DAG can commute.}
	\label{fig:diamond_dag}
\end{figure}

\begin{ab}
  Toute la discussion ci-dessous me semble inutile. Ca parle de
  pruning et d'autres problemes qui n'ont rien a voir avec l'objectif
  de cet article. J'ai peur qu'on se tire une balle dans les pieds. Je
  propose de retirer ce paragraphe
\end{ab}
The productivity advantage of STF must, however, be weighted against
potential limitations as presented by~\citeauthor{y:12}~\cite{y:12}.
For instance unrolling the totality of the DAG on each instance of the runtime
over the distributed memories can be
time-consuming, but it may also require considerable resources for the
management of the DAG when it is sizeable. Several techniques have
been recommended in the literature to alleviate this issue. One such
technique is the pruning of the DAG traversal as depicted in
Figure~\ref{fig:back.stf.pruned} which reduces the DAG generation time
on each rank by only inserting the subset of tasks that are relevant
to this rank~\cite{a.a.f.f.ea:17}; these include tasks that are meant
to be executed locally as well as remote tasks that are connected to
local ones through an inbound or an outbound dependency. A technique
that also limits the processing of irrelevant tasks is hierarchical
tasks: parts of the DAG may be discarded at a high-level in the
hierarchy such that a given rank does not explore the entirety of the
DAG~\cite{p.b.l.a:17,h.l.l.c.l:21,k.l.j.v:21}. The pruning of the DAG can be
put in place by replicating the control of the memory regions managed by the
runtime system as studied in Legion~\cite{s.l.t.z.b.s.m.a:17,b.l.s.j.ea:21}.

\begin{figure}
	\centering
	\begin{tikzpicture}[scale=1]
		% tasks
		% i
		\node[draw,task={mygre}] (t-0-1) at (1.5,0) {};
		% 1
		\node[draw,task={gray},dashed] (t-1-0) at (0.5,-1) {};
		\node[draw,task={myorg}] (t-1-1) at (1.5,-1) {};
		\node[draw,task={gray},dashed] (t-1-2) at (2.5,-1) {};
		% 2
		\node[draw,task={gray},dashed] (t-2-0) at (0.5,-2) {};
		\node[draw,task={myyel}] (t-2-1) at (1.5,-2) {};
		\node[draw,task={gray},dashed] (t-2-2a) at (2.25,-2) {};
		\node[draw,task={gray},dashed] (t-2-2b) at (2.75,-2) {};
		\node[draw,task={gray},dashed] (t-2-3) at (3.5,-2) {};
		% 3
		%\node[draw,task={gray},dashed] (t-3-0) at (0.5,-3) {};
		%\node[draw,task={mygre}] (t-3-1) at (1.5,-3) {};
		%\node[draw,task={gray},dashed] (t-3-2) at (2.25,-3) {};
		%\node[draw,task={gray},dashed] (t-3-3) at (3.5,-3) {};
		% dependencies
		% i
		\path[draw,-latex,ultra thick,myblu] (t-0-1) -- (t-1-0);
		\path[draw,-latex,ultra thick] (t-0-1) -- (t-1-1);
		\path[draw,-latex,ultra thick,myblu] (t-0-1) -- (t-1-2);
		% 1
		\path[draw,-latex,thick,dotted] (t-1-0) -- (t-2-0);
		\path[draw,-latex,ultra thick,myblu] (t-1-0) -- (t-2-1);
		\path[draw,-latex,ultra thick] (t-1-1) -- (t-2-1);
		\path[draw,-latex,thick,dotted] (t-1-2) -- (t-2-2a);
		\path[draw,-latex,thick,dotted] (t-1-2) -- (t-2-2b);
		\path[draw,-latex,thick,dotted,myblu] (t-1-2) -- (t-2-3);
		% 2
		%\path[draw,-latex,thick,dotted] (t-2-0) -- (t-3-0);
		%\path[draw,-latex,ultra thick] (t-2-1) -- (t-3-1);
		%\path[draw,-latex,thick,dotted] (t-2-2a) -- (t-3-2);
		%\path[draw,-latex,ultra thick,myblu] (t-2-2b) -- (t-3-1);
		%\path[draw,-latex,ultra thick,myblu] (t-2-1) -- (t-3-3);
		%\path[draw,-latex,thick,dotted] (t-2-3) -- (t-3-3);
		% nodes
		\path[draw,dashed] (1,0.5) -- (1,-2.5);
		\path[draw,dashed] (2,0.5) -- (2,-2.5);
		\path[draw,dashed] (3,0.5) -- (3,-2.5);
		\node[align=center,text width=1cm,anchor=center] (r0) at (0.5,0.5) {\texttt{\textcolor{black!30}{rk 0}}};
		\node[align=center,text width=1cm,anchor=center] (r1) at (1.5,0.5) {\texttt{rk 1}};
		\node[align=center,text width=1cm,anchor=center] (r2) at (2.5,0.5) {\texttt{\textcolor{black!30}{rk 2}}};
		\node[align=center,text width=1cm,anchor=center] (r3) at (3.5,0.5) {\texttt{\textcolor{black!30}{rk 3}}};
	\end{tikzpicture}
	\caption[A pruned DAG focusing on the operation executed by a single
rank.]
	{A pruned DAG focusing on the operation executed by a single rank.
Discontinued elements are not necessary and as such can be removed from the DAG
inserted at rank 1.}
	\label{fig:back.stf.pruned}
\end{figure}

The STF model is, for example, available in OpenMP (through the \texttt{task}
directive and the \texttt{depend} clause), OmpSs~\cite{d.a.b.l.ea:11} or
StarPU~\cite{a.t.n.w:11}, the runtime system we use in this work. PaRSEC
also provides an STF interface called Dynamic Task Discovery in
reference to the DAG being built at runtime rather than
symbolically~\cite{h.h.b.d:17}. Chunks and Tasks is a lightweight library
that provides an STF programming model where \textit{tasks} get registered
sequentially to use the logically partitioned \textit{chunks} of
memory~\cite{r.r:14}, its authors have also proposed a related linear
algebra library~\cite{r.r.k.a:22}. In the Legion runtime, tasks can be dispatched
dynamically to be executed over the relevant memory regions~\cite{b.t.s.aik:12};
like PaRSEC it provides a domain-specific language to ease the implementation of
applications~\cite{s.l.t.b.a:15}.

To the extent of our knowledge, one element that is not studied in the
literature is redundant computation over multiple ranks in a runtime system, as
we will define in Section~\ref{sec:repl}.
Nonetheless related mechanisms exist such as resiliency
mechanisms. Better guarantees on the resiliency can be obtained through
checkpointing, where the result of tasks is reliably stored, but also task replication,
where multiple identical tasks are scheduled to ensure data is produced even
in case of failure. Designing and implementing such
behaviors within runtime systems is possible without a dramatic overhead and
with little to no intervention from the user~\cite{c.h.b.d:15,l.t:20,g.m.l.k:20}. Our
contribution diverges from resiliency concerns as replicating data accesses
enables data production over all the replicating ranks. The focus of 
redundant computation %data write replication 
is to shorten the critical path of applications and increase their performance.
%\begin{itemize}
%\item Mark Hoemmen CA=s-step krylov subspace methods~\cite{h:10}
%	\begin{itemize}
%	\item CA-GMRES over GPUs~\cite{y.i.a.t.h.d:14}
%	\end{itemize}


%\item Carson stability of CA=s-step krylov subspace methods~\cite{c:15}
%	\begin{itemize}
%	\item s-step=CA Krylov subspace methods CA-BiCG, CA-BiCGSTAB~\cite{c.k.d:13}
%	\item w/ Solomonik and Knight synchronization vs latency vs bandwidth~\cite{b.c.d.hea:14}
%	\item redesign of s-step CG~\cite{c:18}
%	\end{itemize}
%\item Ghysels redesign GMRES to overlap comm and comp~\cite{g.a.m.v:13}
%\item Writing stencil/iterative solver/powers kernel better
%	\begin{itemize}
%	\item CG with a runtime system~\cite{a.g.g.n.r:13}
%	\item ParalleX for stencil~\cite{h.k.i:13}
%	\item Compiler techniques in multigrid for CA / wavefront / tiling optimizations~\cite{b.v.h.w.ea:13}
%	\item PaRSEC classic stencil~\cite{b.b.a.c:14}
%	\item FMM helps OpenMP through StarPU~\cite{a.a.b.c.p:17}
%	\item PaRSEC CA stencil~\cite{p.c.b.l.e.d:20}
%	\item Trilinos s-step~\cite{y.t.h.b.s.e:20}
%	\end{itemize}
%\end{itemize}


% \begin{itemize}
% %	\item Computations over meshes (stencil) eq. SpMV with implicit entries
% 	\item SpMV core computation in iterative solvers
% 	\item Design of scalable variants of krylov subspace methods: GMRES, CG and many others
% 	\item More generally, this feeds into parametrizing algorithms to adapt to different architectures whether latency/bandwidth/... is favorable
% 	\item Ubiquitous computation: how to write it productively?
% 	\begin{itemize}
% 		\item multicore, accelerated platforms, cluster
% 	\end{itemize}
% \end{itemize}


%In Section~\ref{sec:back.repl.iterative}, algorithms that leverage a
%mesh representation in their computations are presented. The core computation
%for these algorithms is often a sparse matrix-vector multiplication $Ax$ where
%$A$ entries inform on the topology of the mesh and $x$ is an initial state of
%the values over the mesh.
% no
%Such algorithms include
%\textit{s-steps} iterative solvers for which a large part of the computational
%load is taken by the computation of the residual $Ax-b$.


%%% Local Variables:
%%% mode: latex
%%% TeX-master: "submission"
%%% TeX-command-extra-options: "-shell-escape --enable-write18 --synctex=1"
%%% jinx-languages: "en"
%%% End:
